/*
Scrivere un programma che acquisisce in input
lattivit su uno switch a 8 porte nella forma (n.
porta, MAC destinatario, MAC sorgente), quindi
ne mostri il procedimento di inoltro e il filtering
database.

Layout:
Traffico
Porta: 1
d: 0 7 d af f4 54 s: 8 0 37 15 e6 bc
Porta: 2
d: 8 0 37 15 e6 b1 s: 0 12 3f 4a 33 d2
Porta: 3
d: 8 0 37 15 e6 bc s: 0 0 c0 9f a0 97
Porta: 2
d: ff ff ff ff ff ff s: 8 0 37 15 e6 bc
Porta: 8
d: 0 12 3f 4a 33 d2 s: 0 12 3f 76 12 1a
Porta: 0
Learning e forwarding
.....................................
Trama rx su 1 -> broadcast su 2 3 4 5 6 7 8
Trama rx su 2 -> broadcast su 1 3 4 5 6 7 8
Trama rx su 3 -> 1
Trama rx su 2 -> broadcast su 1 3 4 5 6 7 8
Trama rx su 8 -> 2
Filtering database
.....................................
P: 1 MAC: 08 00 37 15 E6 BC
P: 2 MAC: 00 12 3F 4A 33 D2
P: 3 MAC: 00 00 C0 9F A0 97
P: 2 MAC: 08 00 37 15 E6 BC
P: 8 MAC: 00 12 3F 76 12 1A

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "htoi.inc"   // funzione htoi()

typedef struct {
  int porta;
  unsigned char MACd[6];
  unsigned char MACs[6];
} TRAFFICO; TRAFFICO* pt0; TRAFFICO* pt;

typedef struct {
  int porta;
  unsigned char MAC[6];
  int age;
} FILTERINGDB; FILTERINGDB* pf0; FILTERINGDB* pf;

int FromMACtoByte(char* szmac, int offs, int idx);
int isMACequal(unsigned char* mac1, unsigned char* mac2);

int main (void)
{
  int i,j, nT, nF, nPorta;
  char sz[30];


  printf("Traffico\n");
  i = 0;
  do
  {
    printf("Porta: "); scanf("%d",&nPorta);
    fflush(stdin);
    if (nPorta)
    {
        int MACd[6], MACs[6];

        printf("d: ");
        gets(sz);
        sscanf(sz, "%x %x %x %x %x %x", &MACd[0], &MACd[1], &MACd[2], &MACd[3] , &MACd[4], &MACd[5]);
        printf("s: ");
        gets(sz);
        sscanf(sz, "%x %x %x %x %x %x", &MACs[0], &MACs[1], &MACs[2], &MACs[3] , &MACs[4], &MACs[5]);

        if (i==0) { pt0 = malloc(sizeof(TRAFFICO)); pt = pt0;}
        else { pt0 = realloc(pt0,(i+1)*sizeof(*pt0)); pt = pt0+i;}

        pt->porta = nPorta;
        for (j=0; j<6;j++)
        {
          pt->MACd[j]=MACd[j];
          pt->MACs[j]=MACs[j];
        }
        i++; nT = i;
    }
  } while (nPorta!=0);


  printf("\nLearning e forwarding\n.....................................");
  nF = 0;
  for (i=0;i<nT;i++)
  {
    int trovato;

    trovato = 0;
    for (j=0;j<nF;j++)
    {
      if ((pf0+j)->porta==(pt0+i)->porta)
      {
        if (isMACequal((pf0+j)->MAC,(pt0+i)->MACs))
        {
          trovato = 1;
          break;
        }
      }
    }

    if (!trovato)
    {
      if (nF==0) { pf0 = malloc(sizeof(*pf0)); pf = pf0;}
      else { pf0 = realloc(pf0,(nF+1)*sizeof(*pf0)); pf = pf0+nF;}
      nF++;

      pf->porta = (pt0+i)->porta;
      memcpy(pf->MAC,(pt0+i)->MACs,sizeof(pf->MAC));
    }

    trovato = 0;
    for (j=0;j<nF;j++)
    {
      if (isMACequal((pf0+j)->MAC,(pt0+i)->MACd))
      {
        printf("\nTrama ricevuta su %d -> %d",(pt0+i)->porta,(pf0+j)->porta);
        trovato = 1;
      }
    }

    if (!trovato)
    {
      printf("\nTrama ricevuta su %d -> broadcast su ",(pt0+i)->porta);
      for (j=1; j<9; j++)
        if (j!=(pt0+i)->porta) printf("%d ",j);
    }
  }

  printf("\n\nFiltering database\n.....................................\n");
  for (i=0;i<nF;i++)
  {
    printf("\nP: %d MAC: %02X %02X %02X %02X %02X %02X",(pf0+i)->porta,
                       (pf0+i)->MAC[0],(pf0+i)->MAC[1],(pf0+i)->MAC[2],
                       (pf0+i)->MAC[3],(pf0+i)->MAC[4],(pf0+i)->MAC[5]);
  }

  free(pt0);
  free(pf0);

  return 0;
}

int FromMACtoByte(char* szmac, int offs, int idx)
{
  char szByte[3];

  szByte[0]=szmac[offs+idx*3];szByte[1]=szmac[offs+idx*3+1];szByte[2]=0;
  return htoi(szByte);
}

int isMACequal(unsigned char* mac1, unsigned char* mac2)
{
  int i;

  for (i=0;i<6;i++)
  {
    if (*mac1!=*mac2) return 0;
    mac1++; mac2++;
  }
  return 1;
}
